## libspng 0.7.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(libspng C)

set(CMAKE_C_STANDARD 99)

set(SPNG_MAJOR 0)
set(SPNG_MINOR 7)
set(SPNG_REVISION 3)
set(SPNG_VERSION ${SPNG_MAJOR}.${SPNG_MINOR}.${SPNG_REVISION})

option(ENABLE_OPT "Enable architecture-specific optimizations" ON)
option(SPNG_SHARED "Build shared lib" ON)
option(SPNG_STATIC "Build static lib" ON)
option(BUILD_EXAMPLES "Build examples" ON)

include(GNUInstallDirs)

# Allow the usage of [PackageName]_ROOT variables for FindPackage
if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12")
    cmake_policy(SET CMP0074 NEW)
endif()

find_package(ZLIB REQUIRED)
include_directories(${ZLIB_INCLUDE_DIRS})

set(spng_SOURCES spng/spng.c)

if(NOT CMAKE_HOST_WIN32)
    set(spng_LIBS -lm ${ZLIB_LIBRARIES})
else()
    set(spng_LIBS ${ZLIB_LIBRARIES})
endif()

if(NOT ENABLE_OPT)
    add_definitions( -DSPNG_DISABLE_OPT=1 )
endif()

if(SPNG_SHARED)
    add_library(spng SHARED ${spng_SOURCES})
    target_include_directories(spng PUBLIC ${PROJECT_SOURCE_DIR}/spng)
    target_link_libraries(spng ${spng_LIBS})
    install(TARGETS spng DESTINATION lib)

    if(BUILD_EXAMPLES)
        add_executable(example examples/example.c)
        target_include_directories(example PRIVATE ${PROJECT_SOURCE_DIR}/spng)
        target_link_libraries(example spng ${spng_LIBS})
    endif()
endif()

if(SPNG_STATIC)
    add_library(spng_static STATIC ${spng_SOURCES})
    target_include_directories(spng PUBLIC ${PROJECT_SOURCE_DIR}/spng)
    target_compile_definitions(spng_static PUBLIC SPNG_STATIC)
    install(TARGETS spng_static DESTINATION lib)
endif()

install(FILES spng/spng.h DESTINATION include)


if(NOT CMAKE_HOST_WIN32 OR CYGWIN OR MINGW)
    set(prefix      ${CMAKE_INSTALL_PREFIX})
    set(exec_prefix ${CMAKE_INSTALL_PREFIX})
    set(libdir      ${CMAKE_INSTALL_FULL_LIBDIR})
    set(includedir  ${CMAKE_INSTALL_FULL_INCLUDEDIR})
    set(LIBS        "-lz -lm")

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/tests/libspng.pc.in ${CMAKE_CURRENT_BINARY_DIR}/tests/libspng.pc @ONLY)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tests/libspng.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
endif()

=== debian/changelog ===
libspng (0.7.3-3) unstable; urgency=medium

  * d/control: add Depends libspng0 to libspng-dev.
    Thanks to Jordi for the report (Closes: #1030670)

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 07 Feb 2023 21:18:58 +0100

libspng (0.7.3-2) unstable; urgency=medium

  * Source-only upload

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 02 Feb 2023 20:38:28 +0100

libspng (0.7.3-1) unstable; urgency=low

  * Initial release. Closes: #1024643

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 20 Nov 2022 23:58:45 +0100

=== debian/control ===
Source: libspng
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Arch: libpng-dev <!nocheck>,
                    meson,
                    pkg-config,
                    zlib1g-dev
Build-Depends-Indep: mkdocs <!nodoc>,
                     mkdocs-material <!nodoc>,
                     node-jquery <!nodoc>
Standards-Version: 4.6.2
Homepage: https://libspng.org
Vcs-Git: https://salsa.debian.org/debian/libspng.git
Vcs-Browser: https://salsa.debian.org/debian/libspng
Rules-Requires-Root: no

Package: libspng0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: simple, modern libpng alternative
 libspng is a C library for reading and writing Portable Network Graphics
 (PNG) format files with a focus on security and ease of use.
 .
 The simple API allows decoding a PNG file in just a few function calls,
 and no raw pointers or callback functions are involved.
 .
 Following good security practises, code is written according to the rules
 of the CERT C Coding Standard. All integer arithmetic is checked for
 overflow and all error conditions are handled gracefully. The library
 is also continuously fuzzed, scanned by static analyzers and features
 over 1000 test cases.

Package: libspng-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libspng0 (= ${binary:Version}),
         zlib1g-dev,
         ${misc:Depends}
Recommends: libspng-doc
Description: simple, modern libpng alternative - development
 libspng is a C library for reading and writing Portable Network Graphics
 (PNG) format files with a focus on security and ease of use.
 .
 The simple API allows decoding a PNG file in just a few function calls,
 and no raw pointers or callback functions are involved.
 .
 Following good security practises, code is written according to the rules
 of the CERT C Coding Standard. All integer arithmetic is checked for
 overflow and all error conditions are handled gracefully. The library
 is also continuously fuzzed, scanned by static analyzers and features
 over 1000 test cases.
 .
 This package contains the header and development files needed to build
 programs and packages using libspng.

Package: libspng-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: fonts-roboto,
         ${misc:Depends},
         ${mkdocs:Depends}
Description: simple, modern libpng alternative - documentation
 libspng is a C library for reading and writing Portable Network Graphics
 (PNG) format files with a focus on security and ease of use.
 .
 The simple API allows decoding a PNG file in just a few function calls,
 and no raw pointers or callback functions are involved.
 .
 Following good security practises, code is written according to the rules
 of the CERT C Coding Standard. All integer arithmetic is checked for
 overflow and all error conditions are handled gracefully. The library
 is also continuously fuzzed, scanned by static analyzers and features
 over 1000 test cases.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

# optimize=-lto because I use Meson's LTO
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto qa=+all

%:
	dh $@ --buildsystem=meson

# Running Meson isn't needed when building the -doc package
%-indep:
	dh $@ --buildsystem=none

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  test := true
else
  test := false
endif

override_dh_auto_configure:
	dh_auto_configure -- \
		-Db_lto=true \
		-Ddev_build=$(test) \
		-Denable_opt=false

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
# The sed call brutally removes every external stylesheet or font, as they
# automatically download things from the internet and trigger Lintian's
# privacy breach warnings.
execute_after_dh_auto_build-indep:
	mkdocs build
	find site -type f -exec sed -i 's|<link [^>]*href="http[^>]*>||g' '{}' ';'

# dh_mkdocs hangs when using --theme-package
execute_after_dh_installdocs-indep:
	dh_mkdocs --indep #--theme-package=mkdocs-material
endif

## libspng 0.7.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(libspng C)

set(CMAKE_C_STANDARD 99)

set(SPNG_MAJOR 0)
set(SPNG_MINOR 7)
set(SPNG_REVISION 4)
set(SPNG_VERSION ${SPNG_MAJOR}.${SPNG_MINOR}.${SPNG_REVISION})

option(ENABLE_OPT "Enable architecture-specific optimizations" ON)
option(SPNG_SHARED "Build shared lib" ON)
option(SPNG_STATIC "Build static lib" ON)
option(BUILD_EXAMPLES "Build examples" ON)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

if(NOT CMAKE_HOST_WIN32)
    set(MATH_LIBRARY "m")
else()
    set(MATH_LIBRARY "")
endif()

if(NOT ENABLE_OPT)
    add_definitions( -DSPNG_DISABLE_OPT=1 )
endif()

set(spng_TARGETS "")

set(spng_SOURCES spng/spng.c)

if(SPNG_SHARED)
    add_library(spng SHARED ${spng_SOURCES})
    list(APPEND spng_TARGETS spng)

    if(BUILD_EXAMPLES)
        add_executable(example examples/example.c)
        target_link_libraries(example PRIVATE spng)
    endif()
endif()

if(SPNG_STATIC)
    add_library(spng_static STATIC ${spng_SOURCES})
    target_compile_definitions(spng_static PUBLIC SPNG_STATIC)
    list(APPEND spng_TARGETS spng_static)
endif()

find_package(ZLIB REQUIRED)
foreach(spng_TARGET ${spng_TARGETS})
    target_include_directories(${spng_TARGET} PUBLIC
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/spng>
      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    )
    target_link_libraries(${spng_TARGET} PRIVATE ZLIB::ZLIB)
    target_link_libraries(${spng_TARGET} PRIVATE ${MATH_LIBRARY})
endforeach()

set(project_config "${CMAKE_CURRENT_BINARY_DIR}/SPNGConfig.cmake")
set(project_version_config "${CMAKE_CURRENT_BINARY_DIR}/SPNGConfigVersion.cmake")
set(targets_export_name SPNGTargets)
set(config_install_dir "${CMAKE_INSTALL_LIBDIR}/cmake/spng")

configure_package_config_file(cmake/Config.cmake.in ${project_config}
  INSTALL_DESTINATION ${config_install_dir}
)

write_basic_package_version_file(${project_version_config}
  VERSION ${SPNG_VERSION}
  COMPATIBILITY SameMajorVersion
)

install(
  TARGETS ${spng_TARGETS}
  EXPORT ${targets_export_name}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

install(FILES spng/spng.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(
  FILES ${project_config} ${project_version_config}
  DESTINATION ${config_install_dir}
)

install(
  EXPORT ${targets_export_name}
  NAMESPACE "spng::"
  DESTINATION ${config_install_dir}
)

if(NOT CMAKE_HOST_WIN32 OR CYGWIN OR MINGW)
    set(prefix      ${CMAKE_INSTALL_PREFIX})
    set(exec_prefix ${CMAKE_INSTALL_PREFIX})
    set(libdir      ${CMAKE_INSTALL_FULL_LIBDIR})
    set(includedir  ${CMAKE_INSTALL_FULL_INCLUDEDIR})
    set(LIBS        "-lm")

    foreach(libname ${spng_TARGETS})
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/libspng.pc.in ${CMAKE_CURRENT_BINARY_DIR}/cmake/lib${libname}.pc @ONLY)

        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmake/lib${libname}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
    endforeach()
endif()

=== meson_options.txt ===
option('dev_build', type : 'boolean', value : false, description : 'Enable the testsuite, requires libpng')
option('enable_opt', type : 'boolean', value : true, description : 'Enable architecture-specific optimizations')
option('use_miniz', type : 'boolean', value : false, description : 'Compile with miniz instead of zlib, disables some features')
option('static_zlib', type : 'boolean', value : false, description : 'Link zlib statically')
option('benchmarks', type : 'boolean', value : false, description : 'Enable benchmarks, requires Git LFS')
option('build_examples', type : 'boolean', value : true, description : 'Build examples, overriden by dev_build')


# Not for end-users
option('multithreading', type : 'feature', value : 'disabled', description : 'Experimental multithreading features')
option('oss_fuzz', type : 'boolean', value : false, description : 'Enable regression tests with OSS-Fuzz corpora')

=== debian/changelog ===
libspng (0.7.4-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:47:36 +0200

libspng (0.7.4-1) unstable; urgency=medium

  * New upstream version 0.7.4
    - Fix decode error for zero-length EXIF

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 09 May 2023 09:51:24 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: libspng
 Section: libs
 Priority: optional
-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
 Build-Depends: debhelper-compat (= 13)
 Build-Depends-Arch: libpng-dev <!nocheck>,
                     meson,

=== debian/tests/control ===
Tests: pkgconfig
Depends: gcc | c-compiler,
         libc-dev,
         pkg-config,
         @

=== debian/watch ===
version=4
https://libspng.org/download/ \
.+/v?@ANY_VERSION@@ARCHIVE_EXT@
